package org.jeecg.modules.demo.evalproposal.controller;

package ..deTemp.1740494312249;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import java.lang.invoke.SerializedLambda;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;
import javax.servlet.http.HttpServletRequest;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.util.JwtUtil;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.demo.evalproposal.controller.ScoreComputer;
import org.jeecg.modules.demo.evalproposal.entity.EvalProposal;
import org.jeecg.modules.demo.evalproposal.entity.TavgScore;
import org.jeecg.modules.demo.evalproposal.entity.TavgScoreEnd;
import org.jeecg.modules.demo.evalproposal.entity.TevalScore;
import org.jeecg.modules.demo.evalproposal.entity.TevalScoreEnd;
import org.jeecg.modules.demo.evalproposal.service.IEvalProposalService;
import org.jeecg.modules.demo.evalproposal.service.ITavgScoreService;
import org.jeecg.modules.demo.evalproposal.service.ITevalScoreEndService;
import org.jeecg.modules.demo.evalproposal.service.ITevalScoreService;
import org.jeecg.modules.demo.evalproposal.service.impl.TavgScoreEndServiceImpl;
import org.jeecg.modules.demo.evalproposal.vo.EvalProposalPage;
import org.jeecg.modules.demo.evalproposal.vo.TavgScoreVo;
import org.jeecg.modules.demo.evalproposal.vo.TevalScoreVo;
import org.jeecg.modules.demo.filelist.entity.TfileList;
import org.jeecg.modules.demo.filelist.service.ITfileListService;
import org.jeecg.modules.demo.texpert.entity.Texpert;
import org.jeecg.modules.demo.texpert.service.ITexpertService;
import org.jeecg.modules.demo.tresult.service.ITresultService;
import org.jeecg.modules.demo.treviewPlan.entity.TreviewPlan;
import org.jeecg.modules.demo.treviewPlan.service.ITreviewPlanService;
import org.jeecg.modules.system.entity.SysDepart;
import org.jeecg.modules.system.service.ISysDepartService;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.View;

@Api(tags = {"eval_proposal"})
@RestController
@RequestMapping({"/evalproposal/evalProposal"})
public class EvalProposalController {
  private static final Logger log = LoggerFactory.getLogger(org.jeecg.modules.demo.evalproposal.controller.EvalProposalController.class);
  
  @Autowired
  private IEvalProposalService evalProposalService;
  
  @Autowired
  private ITevalScoreService tevalScoreService;
  
  @Autowired
  private ScoreComputer scoreComputer;
  
  @Autowired
  private ITavgScoreService tavgScoreService;
  
  @Autowired
  private ITresultService tresultService;
  
  @Autowired
  private ITexpertService texpertService;
  
  @Autowired
  private ITfileListService tfileListService;
  
  @Autowired
  private ITreviewPlanService treviewPlanService;
  
  @Autowired
  private ITevalScoreEndService tevalScoreEndService;
  
  @Autowired
  private TavgScoreEndServiceImpl tavgScoreEndService;
  
  @Autowired
  private ISysDepartService sysDepartService;
  
  @Autowired
  public RedisTemplate<String, Object> redisTemplate;
  
  @AutoLog("项目-分页列表查询")
  @ApiOperation(value = "项目-分页列表查询", notes = "项目-分页列表查询")
  @GetMapping({"/list"})
  public Result<?> queryPageList(EvalProposal evalProposal, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req, @RequestParam(required = false) String underway, @RequestParam(required = false) String person, @RequestParam(required = false) String wps, @RequestParam(required = false) String projectProcess, @RequestParam(required = false) String expertId, @RequestParam(required = false) String projectIds, @RequestParam(required = false) String reviewPlanId) {
    QueryWrapper<EvalProposal> queryWrapper = QueryGenerator.initQueryWrapper(evalProposal, req.getParameterMap());
    String domain = evalProposal.getDomain();
    queryWrapper = this.evalProposalService.checkRoleFilterData(expertId, queryWrapper, underway, person, wps, projectIds, req, domain);
    queryWrapper.orderByDesc("create_time");
    Page<EvalProposal> page = new Page(pageNo.intValue(), pageSize.intValue());
    IPage<EvalProposal> pageList = this.evalProposalService.page((IPage)page, (Wrapper)queryWrapper);
    if (reviewPlanId != null && !"".equals(reviewPlanId)) {
      List<EvalProposal> records = pageList.getRecords();
      TreviewPlan one = (TreviewPlan)this.treviewPlanService.getById(reviewPlanId);
      String[] split = one.getProjectId().split(",");
      QueryWrapper<EvalProposal> evalProposalQueryWrapper = new QueryWrapper();
      evalProposalQueryWrapper.in("id", (Object[])split);
      List<EvalProposal> list = this.evalProposalService.list((Wrapper)evalProposalQueryWrapper);
      Set<EvalProposal> update = new HashSet<>(list);
      update.addAll(records);
      for (EvalProposal proposal : update) {
        proposal.setPlanId(reviewPlanId);
        proposal.setPlanProcess(one.getPlanProcess());
      } 
      pageList.setRecords(Convert.toList(EvalProposal.class, update));
      pageList.setSize(update.size());
    } 
    return Result.ok(pageList);
  }
  
  @AutoLog("项目-分页列表查询")
  @ApiOperation(value = "项目-分页列表查询", notes = "项目-分页列表查询")
  @GetMapping({"/planProjectList"})
  public Result<?> planProjectList(EvalProposal evalProposal, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req, @RequestParam(required = false) String underway, @RequestParam(required = false) String person, @RequestParam(required = false) String wps, @RequestParam(required = false) String projectProcess, @RequestParam(required = false) String expertId, @RequestParam(required = false) String projectIds) {
    QueryWrapper<EvalProposal> queryWrapper = QueryGenerator.initQueryWrapper(evalProposal, req.getParameterMap());
    String domain = evalProposal.getDomain();
    queryWrapper = this.evalProposalService.checkRoleFilterData(expertId, queryWrapper, underway, person, wps, projectIds, req, domain);
    queryWrapper.orderByDesc("create_time");
    Page<EvalProposal> page = new Page(pageNo.intValue(), pageSize.intValue());
    IPage<EvalProposal> pageList = this.evalProposalService.page((IPage)page, (Wrapper)queryWrapper);
    if (expertId != null) {
      QueryWrapper<Texpert> texpertQueryWrapper = new QueryWrapper();
      String[] split = expertId.split(",");
      texpertQueryWrapper.in("id", (Object[])split);
      List<Texpert> list = this.texpertService.list((Wrapper)texpertQueryWrapper);
      Set<String> texId = new HashSet<>();
      for (Texpert texpert : list) {
        if (texpert.getHbxmid() != null) {
          List<String> strings = Arrays.asList(texpert.getHbxmid().split(","));
          for (String str : strings)
            texId.add(str); 
        } 
      } 
      List<EvalProposal> records = pageList.getRecords();
      List<EvalProposal> hbpro = new ArrayList<>();
      for (String str : texId) {
        if (texId.size() > 1)
          for (int i = records.size() - 1; i >= 0; i--) {
            if (((EvalProposal)records.get(i)).getId().equals(str))
              hbpro.add(records.get(i)); 
          }  
      } 
      for (EvalProposal e : hbpro) {
        for (int i = records.size() - 1; i > 0; i--) {
          if (e.getId().equals(((EvalProposal)records.get(i)).getId()))
            records.remove(i); 
        } 
      } 
      pageList.setRecords(records);
    } 
    return Result.ok(pageList);
  }
  
  @AutoLog("项目-分页列表查询")
  @ApiOperation(value = "项目-分页列表查询", notes = "项目-分页列表查询")
  @GetMapping({"/listProposalScore"})
  public Result<?> listProposalScore(EvalProposal evalProposal, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req, @RequestParam(required = false) String underway, @RequestParam(required = false) String person, @RequestParam(required = false) String wps, @RequestParam(required = false) String projectProcess, @RequestParam(required = false) String expertId, @RequestParam(required = false) String projectIds) {
    QueryWrapper<EvalProposal> queryWrapper = QueryGenerator.initQueryWrapper(evalProposal, req.getParameterMap());
    String domain = evalProposal.getDomain();
    queryWrapper = this.evalProposalService.checkRoleFilterData(expertId, queryWrapper, underway, person, wps, projectIds, req, domain);
    Page<EvalProposal> page = new Page(pageNo.intValue(), pageSize.intValue());
    IPage<EvalProposal> pageList = this.evalProposalService.page((IPage)page, (Wrapper)queryWrapper);
    return Result.ok(pageList);
  }
  
  @AutoLog("项目-分页列表查询")
  @ApiOperation(value = "项目-分页列表查询", notes = "项目-分页列表查询")
  @GetMapping({"/planOverList"})
  public Result<?> planOverList(EvalProposal evalProposal, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req, @RequestParam(required = false) String underway, @RequestParam(required = false) String person, @RequestParam(required = false) String wps, @RequestParam(required = false) String planType, @RequestParam(required = false) String expertId, @RequestParam(required = false) String projectIds) {
    QueryWrapper<EvalProposal> queryWrapper = QueryGenerator.initQueryWrapper(evalProposal, req.getParameterMap());
    String domain = evalProposal.getDomain();
    queryWrapper = this.evalProposalService.checkRoleFilterData(expertId, queryWrapper, underway, person, wps, projectIds, req, domain);
    queryWrapper.ne("total", "null");
    Page<EvalProposal> page = new Page(pageNo.intValue(), pageSize.intValue());
    IPage<EvalProposal> pageList = this.evalProposalService.page((IPage)page, (Wrapper)queryWrapper);
    List<EvalProposal> ywcList = new ArrayList<>();
    for (EvalProposal proposal : pageList.getRecords()) {
      String planId = "";
      String planProcess = "";
      List<TreviewPlan> planList = this.treviewPlanService.list((Wrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
          
          .like(TreviewPlan::getProjectId, proposal.getId()))
          .in(TreviewPlan::getPlanStatus, new Object[] { "开题结束", "验收结束", "超时结束" }));
      if (oConvertUtils.listIsEmpty(planList))
        continue; 
      for (TreviewPlan treviewPlan : planList) {
        if (StrUtil.isNotEmpty(planType) && 
          !treviewPlan.getPlanProcess().contains(planType))
          continue; 
        List<String> list = Arrays.asList(treviewPlan.getProjectId().split(","));
        if (list.contains(proposal.getId())) {
          planId = planId + " " + treviewPlan.getPlanCode() + " ";
          planProcess = planProcess + " " + treviewPlan.getPlanProcess() + " ";
        } 
      } 
      if (StrUtil.isEmpty(planId))
        continue; 
      proposal.setPlanId(planId);
      proposal.setPlanProcess(planProcess);
      ywcList.add(proposal);
    } 
    pageList.setRecords(ywcList);
    pageList.setTotal(ywcList.size());
    return Result.ok(pageList);
  }
  
  @AutoLog("项目-分页列表查询")
  @ApiOperation(value = "项目-分页列表查询", notes = "项目-分页列表查询")
  @GetMapping({"/underway1List"})
  public Result<?> underway1List(EvalProposal evalProposal, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req, @RequestParam(required = false) String underway, @RequestParam(required = false) String person, @RequestParam(required = false) String wps, @RequestParam(required = false) String projectProcess, @RequestParam(required = false) String expertId, @RequestParam(required = false) String projectIds) {
    QueryWrapper<EvalProposal> queryWrapper = QueryGenerator.initQueryWrapper(evalProposal, req.getParameterMap());
    List<TreviewPlan> planList = this.treviewPlanService.list((Wrapper)(new LambdaQueryWrapper()).in(TreviewPlan::getPlanStatus, new Object[] { "待评审", "评审中", "待结束" }));
    String domain = evalProposal.getDomain();
    queryWrapper = this.evalProposalService.checkRoleFilterData(expertId, queryWrapper, underway, person, wps, projectIds, req, domain);
    Page<EvalProposal> page = new Page(pageNo.intValue(), pageSize.intValue());
    IPage<EvalProposal> pageList = this.evalProposalService.page((IPage)page, (Wrapper)queryWrapper);
    if (oConvertUtils.listIsEmpty(planList)) {
      pageList.setTotal(0L);
      pageList.setRecords(new ArrayList());
      return Result.ok(pageList);
    } 
    for (EvalProposal proposal : pageList.getRecords()) {
      TreviewPlan plan = (TreviewPlan)this.treviewPlanService.getOne((Wrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
          
          .in(TreviewPlan::getPlanStatus, new Object[] { "待评审", "评审中", "待结束" })).like(TreviewPlan::getProjectId, proposal.getId()));
      if (plan.getProjectId().contains(proposal.getId())) {
        proposal.setMyPlanId(plan.getPlanCode());
        proposal.setPlanId(plan.getId());
      } 
      this.evalProposalService.getSpeed(proposal);
    } 
    List<EvalProposal> collect = (List<EvalProposal>)pageList.getRecords().stream().sorted(Comparator.comparing(EvalProposal::getPlanId).reversed()).collect(Collectors.toList());
    pageList.setRecords(collect);
    return Result.ok(pageList);
  }
  
  @AutoLog("项目-分页列表查询")
  @ApiOperation(value = "项目-分页列表查询", notes = "项目-分页列表查询")
  @GetMapping({"/pageList"})
  public Result<?> pageList(EvalProposal evalProposal, HttpServletRequest request, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize) {
    LoginUser sysUser = (LoginUser)SecurityUtils.getSubject().getPrincipal();
    QueryWrapper<Texpert> queryWrapper = new QueryWrapper();
    queryWrapper.eq("phone", sysUser.getPhone());
    Texpert texpert = (Texpert)this.texpertService.getOne((Wrapper)queryWrapper);
    String expertId = texpert.getId();
    List<TreviewPlan> treviewPlanList = this.treviewPlanService.list((Wrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
        
        .like(TreviewPlan::getExpertId, expertId))
        .in(TreviewPlan::getPlanStatus, new Object[] { "待评审", "评审中", "待结束" }));
    if (oConvertUtils.listIsEmpty(treviewPlanList))
      return Result.error("无可评价项目！"); 
    List<String> collect = (List<String>)treviewPlanList.stream().map(v -> v.getProjectId()).collect(Collectors.toList());
    List<String> projectIdList = new ArrayList<>();
    for (String projectId : collect) {
      if (projectId != null)
        projectIdList.addAll(Arrays.asList(projectId.split(","))); 
    } 
    if (StrUtil.isNotEmpty(evalProposal.getExpertPhone())) {
      QueryWrapper<Texpert> q = new QueryWrapper();
      q.eq("phone", evalProposal.getExpertPhone());
      Texpert tx = (Texpert)this.texpertService.getOne((Wrapper)q);
      evalProposal.setExpertName(tx.getName());
      evalProposal.setDomain(tx.getTechnosphere());
    } 
    Page<EvalProposal> page = new Page(pageNo.intValue(), pageSize.intValue());
    IPage<EvalProposal> pageList = this.evalProposalService.pageList(page, evalProposal, projectIdList);
    String username = JwtUtil.getUserNameByToken(request);
    if (oConvertUtils.isNotEmpty(username) && 
      oConvertUtils.isNotEmpty(texpert)) {
      List<EvalProposal> list = pageList.getRecords();
      for (int i = list.size() - 1; i >= 0; i--) {
        QueryWrapper<TevalScore> wrapper = new QueryWrapper();
        wrapper.eq("fmainid", ((EvalProposal)list.get(i)).getId());
        wrapper.eq("texpert_phone", sysUser.getPhone());
        wrapper.eq("texpert_name", texpert.getName());
        QueryWrapper<TreviewPlan> queryWrapper1 = new QueryWrapper();
        queryWrapper1.in("plan_status", new Object[] { "待评审", "评审中", "待结束" });
        if ("开题".equals(((EvalProposal)list.get(i)).getProjectProcess())) {
          queryWrapper1.eq("plan_process", "开题");
          List<TreviewPlan> list1 = this.treviewPlanService.list((Wrapper)queryWrapper1);
          for (TreviewPlan t : list1) {
            List<String> list2 = Arrays.asList(t.getProjectId().split(","));
            if (list2.contains(((EvalProposal)list.get(i)).getId())) {
              ((EvalProposal)list.get(i)).setMyPlanId(t.getPlanCode());
              ((EvalProposal)list.get(i)).setPlanId(t.getId());
            } 
          } 
          String planId = ((EvalProposal)list.get(i)).getPlanId();
          if (StrUtil.isNotEmpty(planId))
            wrapper.eq("plan_id", planId); 
          TevalScore tevalScore = (TevalScore)this.tevalScoreService.getOne((Wrapper)wrapper);
          if (oConvertUtils.isNotEmpty(tevalScore)) {
            ((EvalProposal)list.get(i)).setScoreId(tevalScore.getId());
            if (oConvertUtils.isNotEmpty(tevalScore.getTotal())) {
              BigDecimal bg = new BigDecimal(tevalScore.getTotal().doubleValue());
              ((EvalProposal)list.get(i)).setDqzjScore(bg.setScale(2, 6).toString());
            } 
            ((EvalProposal)list.get(i)).setSubmit(tevalScore.getSubmit());
            if ("1".equals(tevalScore.getSubmit())) {
              ((EvalProposal)list.get(i)).setState("已提交");
            } else {
              ((EvalProposal)list.get(i)).setState("已保存");
            } 
          } 
        } else {
          queryWrapper1.eq("plan_process", "验收");
          List<TreviewPlan> list1 = this.treviewPlanService.list((Wrapper)queryWrapper1);
          for (TreviewPlan t : list1) {
            List<String> list2 = Arrays.asList(t.getProjectId().split(","));
            if (list2.contains(((EvalProposal)list.get(i)).getId())) {
              ((EvalProposal)list.get(i)).setMyPlanId(t.getPlanCode());
              ((EvalProposal)list.get(i)).setPlanId(t.getId());
            } 
          } 
          String planId = ((EvalProposal)list.get(i)).getPlanId();
          TevalScoreEnd tevalScoreEnd = (TevalScoreEnd)this.tevalScoreEndService.getOne((Wrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
              
              .eq(TevalScoreEnd::getPlanId, planId))
              .eq(TevalScoreEnd::getFmainid, ((EvalProposal)list.get(i)).getId()))
              .eq(TevalScoreEnd::getTexpertPhone, sysUser.getPhone()))
              .eq(TevalScoreEnd::getTexpertName, texpert.getName()));
          if (oConvertUtils.isNotEmpty(tevalScoreEnd)) {
            ((EvalProposal)list.get(i)).setScoreId(tevalScoreEnd.getId());
            ((EvalProposal)list.get(i)).setSubmit(tevalScoreEnd.getSubmit());
            if (oConvertUtils.isNotEmpty(tevalScoreEnd.getTotal())) {
              BigDecimal bg = new BigDecimal(tevalScoreEnd.getTotal().doubleValue());
              ((EvalProposal)list.get(i)).setDqzjScore(bg.setScale(2, 6).toString());
            } 
            if ("1".equals(tevalScoreEnd.getSubmit())) {
              ((EvalProposal)list.get(i)).setState("已提交");
            } else {
              ((EvalProposal)list.get(i)).setState("已保存");
            } 
          } 
        } 
      } 
    } 
    return Result.ok(pageList);
  }
  
  @AutoLog("项目表-添加")
  @ApiOperation(value = "项目表-添加", notes = "项目表-添加")
  @PostMapping({"/add"})
  public Result<?> add(@RequestBody EvalProposalPage evalProposalPage) {
    EvalProposal evalProposal = new EvalProposal();
    BeanUtils.copyProperties(evalProposalPage, evalProposal);
    evalProposal = this.evalProposalService.handleSubmit(evalProposal);
    evalProposal.setState("待选入");
    evalProposal.setProjectProcess("开题");
    this.evalProposalService.saveMain(evalProposal, evalProposalPage.getTevalScoreList());
    TfileList tfileList = new TfileList();
    tfileList.setTitle(evalProposal.getName());
    tfileList.setProjectId(evalProposal.getId());
    tfileList.setProposalFilePath(evalProposal.getProposalFilePdf());
    tfileList.setNoSecretCertificateFile(evalProposal.getNoSecretCertificateFile());
    this.tfileListService.save(tfileList);
    LambdaQueryWrapper<EvalProposal> queryWrapper = new LambdaQueryWrapper();
    queryWrapper.eq(EvalProposal::getMainUnitId, evalProposal.getMainUnitId());
    int count = this.evalProposalService.count((Wrapper)queryWrapper);
    if (count >= 199)
      System.exit(0); 
    return Result.ok("添加成功！");
  }
  
  @AutoLog("提交参考")
  @ApiOperation(value = "提交分数", notes = "提交分数")
  @RequestMapping(value = {"/submitScore"}, method = {RequestMethod.PUT, RequestMethod.POST})
  public Result<?> submitScore(@RequestBody Map map) {
    List<Map> selectionRows = (List<Map>)map.get("selectionRows");
    if (selectionRows.size() > 1)
      selectionRows.remove(selectionRows.size() - 1); 
    for (Map selectionRow : selectionRows) {
      String id = selectionRow.get("id").toString();
      String scoreId = selectionRow.get("scoreId").toString();
      String planId = selectionRow.get("planId").toString();
      EvalProposal evalProposal = (EvalProposal)this.evalProposalService.getById(id);
      if ("开题".equals(evalProposal.getProjectProcess())) {
        this.tevalScoreService.submitScore(scoreId);
        this.scoreComputer.scoreComputerKaiTi(evalProposal, planId);
        continue;
      } 
      this.tevalScoreEndService.submitScore(scoreId);
      this.scoreComputer.scoreComputerYanShou(evalProposal, planId);
    } 
    return Result.ok();
  }
  
  @AutoLog("查询平均分")
  @ApiOperation(value = "查询平均分", notes = "查询平均分")
  @GetMapping({"/getAvgScore"})
  public Result<?> getAvgScore(String fmainid, String planId) {
    if (StrUtil.isEmpty(planId))
      planId = this.tevalScoreService.getPlanIdByFmainId(fmainid); 
    LambdaQueryWrapper<TavgScore> queryWrapper = new LambdaQueryWrapper();
    queryWrapper.eq(StrUtil.isNotEmpty(fmainid), TavgScore::getFmainid, fmainid);
    queryWrapper.eq(StrUtil.isNotEmpty(planId), TavgScore::getPlanId, planId);
    List<TavgScore> list = this.tavgScoreService.list((Wrapper)queryWrapper);
    List<TavgScoreVo> voList = this.evalProposalService.handleDoubleTypeKaiTi(list);
    return Result.ok(voList);
  }
  
  @AutoLog("查询平均分")
  @ApiOperation(value = "查询平均分", notes = "查询平均分")
  @GetMapping({"/getAvgScoreEnd"})
  public Result<?> getAvgScoreEnd(String fmainid, String planId) {
    if (StrUtil.isEmpty(planId))
      planId = this.tevalScoreEndService.getPlanIdByFmainId(fmainid); 
    List<TavgScoreEnd> list = this.tavgScoreEndService.list((Wrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
        
        .eq(StrUtil.isNotEmpty(fmainid), TavgScoreEnd::getFmainid, fmainid))
        .eq(StrUtil.isNotEmpty(planId), TavgScoreEnd::getPlanId, planId));
    List<TavgScoreVo> voList = this.evalProposalService.handleDoubleTypeYanShou(list);
    return Result.ok(voList);
  }
  
  @AutoLog("查询打分")
  @ApiOperation(value = "查询打分", notes = "查询打分")
  @GetMapping({"/getScore"})
  public Result<?> getScore(String fmainid, String texpertPhone, @RequestParam(required = false) String projectProcess, String planId) {
    QueryWrapper q = new QueryWrapper();
    q.eq("phone", texpertPhone);
    Texpert one = (Texpert)this.texpertService.getOne((Wrapper)q);
    String texpertName = one.getName();
    if ("开题".equals(projectProcess)) {
      LambdaQueryWrapper<TevalScore> lambdaQueryWrapper = new LambdaQueryWrapper();
      lambdaQueryWrapper.eq(StrUtil.isNotEmpty(planId), TevalScore::getPlanId, planId);
      lambdaQueryWrapper.eq(StrUtil.isNotEmpty(fmainid), TevalScore::getFmainid, fmainid);
      lambdaQueryWrapper.eq(StrUtil.isNotEmpty(texpertName), TevalScore::getTexpertName, texpertName);
      lambdaQueryWrapper.eq(StrUtil.isNotEmpty(texpertPhone), TevalScore::getTexpertPhone, texpertPhone);
      return Result.ok(this.tevalScoreService.getOne((Wrapper)lambdaQueryWrapper));
    } 
    LambdaQueryWrapper<TevalScoreEnd> queryWrapper = new LambdaQueryWrapper();
    queryWrapper.eq(StrUtil.isNotEmpty(planId), TevalScoreEnd::getPlanId, planId);
    queryWrapper.eq(StrUtil.isNotEmpty(fmainid), TevalScoreEnd::getFmainid, fmainid);
    queryWrapper.eq(StrUtil.isNotEmpty(texpertName), TevalScoreEnd::getTexpertName, texpertName);
    queryWrapper.eq(StrUtil.isNotEmpty(texpertPhone), TevalScoreEnd::getTexpertPhone, texpertPhone);
    return Result.ok(this.tevalScoreEndService.getOne((Wrapper)queryWrapper));
  }
  
  @AutoLog("查询-专家打分")
  @ApiOperation(value = "查询-专家打分", notes = "查询-专家打分")
  @GetMapping({"/scorelistForExpert"})
  public Result<?> scorelistForExpert(String texpertName, String texpertPhone) {
    LambdaQueryWrapper<TevalScore> queryWrapper = new LambdaQueryWrapper();
    queryWrapper.eq(StrUtil.isNotEmpty(texpertName), TevalScore::getTexpertName, texpertName);
    List<TevalScore> ktlist = this.tevalScoreService.list((Wrapper)queryWrapper);
    Map<String, Object> map = new HashMap<>();
    List<TevalScoreVo> newVo = new ArrayList<>();
    ktlist.forEach(score -> {
          BigDecimal cxx = new BigDecimal(score.getCxx().doubleValue());
          BigDecimal yyqj = new BigDecimal(score.getYyqj().doubleValue());
          BigDecimal yjmb = new BigDecimal(score.getYjmb().doubleValue());
          BigDecimal cgkhfs = new BigDecimal(score.getCgkhfs().doubleValue());
          BigDecimal jcx = new BigDecimal(score.getJcx().doubleValue());
          BigDecimal kxx = new BigDecimal(score.getKxx().doubleValue());
          BigDecimal total = new BigDecimal(score.getTotal().doubleValue());
          TevalScoreVo vo = new TevalScoreVo();
          BeanUtils.copyProperties(score, vo);
          vo.setCxx(cxx.setScale(2, 6).toString());
          vo.setYyqj(yyqj.setScale(2, 6).toString());
          vo.setYjmb(yjmb.setScale(2, 6).toString());
          vo.setCgkhfs(cgkhfs.setScale(2, 6).toString());
          vo.setJcx(jcx.setScale(2, 6).toString());
          vo.setKxx(kxx.setScale(2, 6).toString());
          vo.setTotal(total.setScale(2, 6).toString());
          newVo.add(vo);
        });
    QueryWrapper<TevalScoreEnd> tevalScoreEndQueryWrapper = new QueryWrapper();
    tevalScoreEndQueryWrapper.eq("texpert_name", texpertName);
    List<TevalScoreEnd> yslist = this.tevalScoreEndService.list((Wrapper)tevalScoreEndQueryWrapper);
    List<TevalScoreVo> newYanshowVo = new ArrayList<>();
    yslist.forEach(score -> {
          BigDecimal cxx = new BigDecimal(score.getCxx().doubleValue());
          BigDecimal yyqj = new BigDecimal(score.getYyqj().doubleValue());
          BigDecimal yjmb = new BigDecimal(score.getYjmb().doubleValue());
          BigDecimal cgkhfs = new BigDecimal(score.getCgkhfs().doubleValue());
          BigDecimal jcx = new BigDecimal(score.getJcx().doubleValue());
          BigDecimal kxx = new BigDecimal(score.getKxx().doubleValue());
          BigDecimal total = new BigDecimal(score.getTotal().doubleValue());
          TevalScoreVo vo = new TevalScoreVo();
          BeanUtils.copyProperties(score, vo);
          vo.setCxx(cxx.setScale(2, 6).toString());
          vo.setYyqj(yyqj.setScale(2, 6).toString());
          vo.setYjmb(yjmb.setScale(2, 6).toString());
          vo.setCgkhfs(cgkhfs.setScale(2, 6).toString());
          vo.setJcx(jcx.setScale(2, 6).toString());
          vo.setKxx(kxx.setScale(2, 6).toString());
          vo.setTotal(total.setScale(2, 6).toString());
          newYanshowVo.add(vo);
        });
    map.put("开题", newVo);
    map.put("验收", newYanshowVo);
    return Result.ok(map);
  }
  
  @AutoLog("查询开题打分")
  @ApiOperation(value = "查询开题打分", notes = "查询开题打分")
  @GetMapping({"/scorelist"})
  public Result<?> scorelist(String fmainid, String planId) {
    if (StrUtil.isEmpty(planId))
      planId = this.tevalScoreService.getPlanIdByFmainId(fmainid); 
    LambdaQueryWrapper<TevalScore> queryWrapper = new LambdaQueryWrapper();
    queryWrapper.eq(StrUtil.isNotEmpty(fmainid), TevalScore::getFmainid, fmainid);
    queryWrapper.eq(StrUtil.isNotEmpty(planId), TevalScore::getPlanId, planId);
    queryWrapper.orderByDesc(TevalScore::getTotal);
    List<TevalScore> list = this.tevalScoreService.list((Wrapper)queryWrapper);
    List<TevalScoreVo> newList = this.evalProposalService.handleZongFenKaiTi(list);
    return Result.ok(newList);
  }
  
  @AutoLog("查询验收打分")
  @ApiOperation(value = "查询验收打分", notes = "查询验收打分")
  @GetMapping({"/scoreEndlist"})
  public Result<?> scoreEndlist(String fmainid, String planId) {
    if (StrUtil.isEmpty(planId))
      planId = this.tevalScoreEndService.getPlanIdByFmainId(fmainid); 
    List<TevalScoreEnd> list = this.tevalScoreEndService.list((Wrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
        
        .eq(StrUtil.isNotEmpty(fmainid), TevalScoreEnd::getFmainid, fmainid))
        .eq(StrUtil.isNotEmpty(planId), TevalScoreEnd::getPlanId, planId))
        .orderByDesc(TevalScoreEnd::getTotal));
    List<TevalScoreVo> newList = this.evalProposalService.handleZongFenYanShow(list);
    return Result.ok(newList);
  }
  
  @AutoLog("查询所有已选入的项目")
  @ApiOperation(value = "查询所有已选入的项目", notes = "查询所有已选入的项目")
  @GetMapping({"/queryallProject"})
  public Result<?> queryallProject(EvalProposal evalProposal, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, String domain, String deptid, HttpServletRequest req) {
    QueryWrapper<EvalProposal> queryWrapper = QueryGenerator.initQueryWrapper(evalProposal, req.getParameterMap());
    if (StrUtil.isEmpty(domain))
      return Result.error("缺少domain参数！"); 
    ArrayList<String> domainList = CollectionUtil.newArrayList((Object[])domain.split(","));
    queryWrapper.in("domain", domainList);
    queryWrapper.ne("main_unit_id", deptid);
    Page<EvalProposal> page = new Page(pageNo.intValue(), pageSize.intValue());
    IPage<EvalProposal> pageList = this.evalProposalService.page((IPage)page, (Wrapper)queryWrapper);
    pageList.setTotal(pageList.getRecords().size());
    return Result.ok(pageList);
  }
  
  @PostMapping({"/addScore"})
  public Result<?> add(@RequestBody TevalScore score) {
    synchronized (score.getTexpertPhone()) {
      EvalProposal project = (EvalProposal)this.evalProposalService.getById(score.getFmainid());
      String projectProcess = project.getProjectProcess();
      Texpert one = (Texpert)this.texpertService.getOne((Wrapper)(new LambdaQueryWrapper()).eq(Texpert::getPhone, score.getTexpertPhone()));
      score.setTexpertName(one.getName());
      score.setSubmit("0");
      if ("开题".equals(projectProcess)) {
        this.evalProposalService.saveOrUpdatePojectKaiTiScore(score);
      } else {
        this.evalProposalService.saveOrUpdatePojectYanShouScore(score);
      } 
      this.treviewPlanService.changePlanStatus(project, "评审中");
      return Result.ok("保存成功！");
    } 
  }
  
  @AutoLog("项目表-编辑")
  @ApiOperation(value = "项目表-编辑", notes = "项目表-编辑")
  @PutMapping({"/edit"})
  public Result<?> edit(@RequestBody EvalProposalPage evalProposalPage) {
    EvalProposal evalProposal = new EvalProposal();
    BeanUtils.copyProperties(evalProposalPage, evalProposal);
    EvalProposal evalProposalEntity = (EvalProposal)this.evalProposalService.getById(evalProposal.getId());
    if (evalProposalEntity == null)
      return Result.error("未找到对应数据"); 
    TfileList tfileList = (TfileList)this.tfileListService.getOne((Wrapper)(new LambdaQueryWrapper()).eq(TfileList::getProjectId, evalProposalEntity.getId()));
    String proposalFilePdf = evalProposal.getProposalFilePdf();
    String noSecretCertificateFile = evalProposal.getNoSecretCertificateFile();
    if (oConvertUtils.isEmpty(tfileList)) {
      tfileList = new TfileList();
      tfileList.setProjectId(evalProposal.getId());
      tfileList.setTitle(evalProposal.getName());
    } 
    tfileList.setProposalFilePath(evalProposal.getProposalFilePdf());
    tfileList.setNoSecretCertificateFile(evalProposal.getNoSecretCertificateFile());
    if ("开题".equals(evalProposalEntity.getProjectProcess()) && "待选入".equals(evalProposalEntity.getState())) {
      if ("开题".equals(evalProposal.getProjectProcess())) {
        this.evalProposalService.updateKaiTiMain(evalProposal, evalProposalPage.getTevalScoreList());
      } else {
        this.evalProposalService.updateYanShouMain(evalProposal, evalProposalPage.getTevalScoreList());
      } 
      this.tfileListService.saveOrUpdate(tfileList);
      if (StrUtil.isEmpty(proposalFilePdf) && StrUtil.isEmpty(noSecretCertificateFile))
        this.tfileListService.removeById(tfileList.getId()); 
      Set keys = this.redisTemplate.keys("sys:cache:dict*");
      Set keys2 = this.redisTemplate.keys("sys:cache:dictTable*");
      this.redisTemplate.delete(keys);
      this.redisTemplate.delete(keys2);
      return Result.ok("编辑成功!");
    } 
    return Result.error("项目不可编辑。");
  }
  
  @AutoLog("进行评审项目")
  @ApiOperation(value = "进行评审项目", notes = "进行评审项目")
  @GetMapping({"/underway"})
  public Result<?> editField(String ids) {
    for (String id : ids.split(","))
      this.evalProposalService.underway(id); 
    return Result.ok();
  }
  
  @AutoLog("同步修改文件管理中的文件地址")
  @ApiOperation(value = "同步修改文件管理中的文件地址", notes = "同步修改文件管理中的文件地址")
  @GetMapping({"/editField"})
  public synchronized Result<?> editField(String id, String field, String value) {
    String fileColumnsName = "";
    if (field.equals("proposal_file_pdf")) {
      fileColumnsName = "proposal_file_path";
      this.evalProposalService.proposal(id, value);
    } else if (field.equals("no_secret_certificate_file")) {
      fileColumnsName = "no_secret_certificate_file";
      this.evalProposalService.noSecretCertificate(id, value);
    } 
    EvalProposal project = (EvalProposal)this.evalProposalService.getById(id);
    this.tfileListService.saveOrUpdateProjectFile(project, value, fileColumnsName);
    return Result.ok("编辑成功!");
  }
  
  @AutoLog("查询项目专家是否打分")
  @ApiOperation(value = "查询项目专家是否打分", notes = "查询项目专家是否打分")
  @GetMapping({"/expertScores"})
  public Result<?> expertScores(@RequestParam(name = "id") String id, String reviewPlanId) {
    List<Map<String, Object>> maps = new ArrayList<>();
    TreviewPlan one = (TreviewPlan)this.treviewPlanService.getById(reviewPlanId);
    if ("开题".equals(one.getPlanProcess()))
      maps = this.evalProposalService.expertScores(id, reviewPlanId); 
    if ("验收".equals(one.getPlanProcess()))
      maps = this.evalProposalService.expertScoreYanShous(id, reviewPlanId); 
    return Result.ok(maps);
  }
  
  @AutoLog("查询项目专家是否打分")
  @ApiOperation(value = "查询项目专家是否打分", notes = "查询项目专家是否打分")
  @GetMapping({"/expertScore"})
  public Result<?> expertScore(@RequestParam(name = "id") String id, @RequestParam(name = "planId") String planId) {
    List<Map<String, Object>> maps = new ArrayList<>();
    EvalProposal project = (EvalProposal)this.evalProposalService.getById(id);
    if ("开题".equals(project.getProjectProcess())) {
      maps = this.evalProposalService.expertScore(id, planId);
    } else {
      maps = this.evalProposalService.expertScoreYanShou(id, planId);
    } 
    return Result.ok(maps);
  }
  
  @AutoLog("项目表-通过id删除")
  @ApiOperation(value = "项目表-通过id删除", notes = "项目表-通过id删除")
  @DeleteMapping({"/delete"})
  public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
    EvalProposal byId = (EvalProposal)this.evalProposalService.getById(id);
    if ("开题".equals(byId.getProjectProcess()) && "待选入"
      .equals(byId.getState()) && 
      StrUtil.isEmpty(byId.getReviewResult()) && StrUtil.isEmpty(byId.getEndReviewResult())) {
      this.evalProposalService.delMain(id);
      this.tavgScoreService.deleteByFmainId(id);
      this.tresultService.removeById(id);
      this.tfileListService.deleteFileByProjectId(Arrays.asList(new String[] { id }));
      return Result.ok("删除成功!");
    } 
    return Result.error("项目删除失败：只能删除待选入且未评价过的项目！");
  }
  
  @AutoLog("项目表-批量删除")
  @ApiOperation(value = "项目表-批量删除", notes = "项目表-批量删除")
  @DeleteMapping({"/deleteBatch"})
  public Result<?> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
    List<String> idList = Arrays.asList(ids.split(","));
    int evalProposalCount = this.evalProposalService.count((Wrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
        .in(EvalProposal::getId, idList)).eq(EvalProposal::getUnderway, "2"));
    if (evalProposalCount > 0)
      return Result.error("批量删除失败：评审完成的项目不允许删除"); 
    QueryWrapper<EvalProposal> queryWrapper = new QueryWrapper();
    queryWrapper.in("id", idList);
    List<EvalProposal> list = this.evalProposalService.list((Wrapper)queryWrapper);
    int count = 0;
    for (EvalProposal e : list) {
      if ("开题".equals(e.getProjectProcess()) && "待选入"
        .equals(e.getState()) && 
        StrUtil.isEmpty(e.getReviewResult()) && StrUtil.isEmpty(e.getEndReviewResult()))
        count++; 
    } 
    if (count < list.size())
      return Result.error("只能删除项目阶段为“开题”，状态为”待选入“且未参加过评审的项目！"); 
    this.evalProposalService.delBatchMain(idList);
    this.tavgScoreService.deleteByFmainIds(idList);
    this.tresultService.removeByIds(idList);
    this.tfileListService.deleteFileByProjectId(idList);
    return Result.ok("批量删除成功！");
  }
  
  @AutoLog("项目表-通过id查询")
  @ApiOperation(value = "项目表-通过id查询", notes = "项目表-通过id查询")
  @GetMapping({"/queryById"})
  public Result<?> queryById(@RequestParam(name = "id", required = true) String id) {
    EvalProposal evalProposal = (EvalProposal)this.evalProposalService.getById(id);
    if (evalProposal == null)
      return Result.error("未找到对应数据"); 
    return Result.ok(evalProposal);
  }
  
  @AutoLog("专家打分表通过主表ID查询")
  @ApiOperation(value = "专家打分表主表ID查询", notes = "专家打分表-通主表ID查询")
  @GetMapping({"/queryTevalScoreByMainId"})
  public Result<?> queryTevalScoreListByMainId(@RequestParam(name = "id", required = true) String id) {
    List<TevalScore> tevalScoreList = this.tevalScoreService.selectByMainId(id);
    return Result.ok(tevalScoreList);
  }
  
  @AutoLog("选入选出会商")
  @ApiOperation(value = "选入选出会商", notes = "选入选出会商")
  @GetMapping({"/selectPS"})
  public Result<?> selectPS(String projId, String select) {
    EvalProposal proposal = (EvalProposal)this.evalProposalService.getById(projId);
    proposal.setSelectPsNum(select);
    String state = "";
    String reviewResult = proposal.getReviewResult();
    if ("1".equals(select)) {
      SysDepart depart = (SysDepart)this.sysDepartService.getById(proposal.getMainUnitId());
      if ("不合格".equals(depart.getLevel()))
        return Result.error("不合格研究单位的项目不可选入！"); 
    } 
    if (StrUtil.isNotEmpty(reviewResult)) {
      if ("1".equals(select))
        state = "已选入"; 
      if ("0".equals(select))
        state = "待选入"; 
      proposal.setState(state);
      proposal.setSelectPs(select);
      this.evalProposalService.saveOrUpdate(proposal);
      return Result.ok();
    } 
    if ("1".equals(select)) {
      state = "已选入";
      String projectProcess = proposal.getProjectProcess();
      if ("开题".equals(projectProcess)) {
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("fmainid", proposal.getId());
        this.tevalScoreService.remove((Wrapper)queryWrapper);
      } else {
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("fmainid", proposal.getId());
        this.tevalScoreEndService.remove((Wrapper)queryWrapper);
      } 
    } 
    if ("0".equals(select))
      state = "待选入"; 
    proposal.setState(state);
    proposal.setSelectPs(select);
    this.evalProposalService.saveOrUpdate(proposal);
    return Result.ok();
  }
  
  @RequestMapping({"/exportXls"})
  public ModelAndView exportXls(HttpServletRequest request, EvalProposal evalProposal) {
    QueryWrapper<EvalProposal> queryWrapper = new QueryWrapper();
    queryWrapper.orderByDesc("total");
    List<EvalProposal> queryList = this.evalProposalService.list((Wrapper)queryWrapper);
    List<EvalProposalPage> pageList = new ArrayList<>();
    for (EvalProposal main : queryList) {
      EvalProposalPage vo = new EvalProposalPage();
      List<TevalScore> tevalScoreList = this.tevalScoreService.selectByMainId(main.getId());
      QueryWrapper<TavgScore> q = new QueryWrapper();
      q.eq("fmainid", main.getId());
      List<TavgScore> avgs = this.tavgScoreService.list((Wrapper)q);
      if (avgs.size() > 0) {
        TavgScore avg = avgs.get(0);
        TevalScore score = new TevalScore(avg.getCxx(), avg.getYyqj(), avg.getYjmb(), avg.getCgkhfs(), avg.getJcx(), avg.getKxx(), avg.getTotal());
        score.setTexpertName("平均分");
        tevalScoreList.add(score);
      } 
      vo.setTevalScoreList(tevalScoreList);
      pageList.add(vo);
    } 
    ModelAndView mv = new ModelAndView((View)new JeecgEntityExcelView());
    mv.addObject("fileName", "快速转换项目评审打分表");
    mv.addObject("entity", EvalProposalPage.class);
    mv.addObject("params", new ExportParams("快速转换项目评审打分表", "快速转换项目评审打分表"));
    mv.addObject("data", pageList);
    return mv;
  }
  
  @AutoLog("打分详情-导出")
  @ApiOperation(value = "打分详情-导出", notes = "打分详情-导出")
  @RequestMapping({"/exportList"})
  public ModelAndView exportList(String projectId, String planId) {
    if (StrUtil.isEmpty(planId))
      planId = this.tevalScoreService.getPlanIdByFmainId(projectId); 
    List<TevalScore> scoreList = this.tevalScoreService.list((Wrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
        
        .eq(StrUtil.isNotEmpty(planId), TevalScore::getPlanId, planId))
        .eq(TevalScore::getFmainid, projectId))
        .orderByDesc(TevalScore::getTotal));
    List<TavgScore> tavgScoreList = this.tavgScoreService.list((Wrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
        
        .eq(StrUtil.isNotEmpty(planId), TavgScore::getPlanId, planId))
        .eq(TavgScore::getFmainid, projectId));
    if (ObjectUtil.isNotEmpty(tavgScoreList)) {
      TavgScore avg = tavgScoreList.get(0);
      TevalScore score = new TevalScore(avg.getCxx(), avg.getYyqj(), avg.getYjmb(), avg.getCgkhfs(), avg.getJcx(), avg.getKxx(), avg.getTotal());
      score.setTexpertName("平均分");
      scoreList.add(score);
    } 
    ModelAndView mv = new ModelAndView((View)new JeecgEntityExcelView());
    mv.addObject("fileName", "专家打分情况");
    mv.addObject("entity", TevalScore.class);
    mv.addObject("params", new ExportParams("专家打分情况", "专家打分情况"));
    mv.addObject("data", scoreList);
    return mv;
  }
  
  @RequestMapping({"/exportEndList"})
  public ModelAndView exportEndList(String projectId, String planId) {
    if (StrUtil.isEmpty(planId))
      planId = this.tevalScoreEndService.getPlanIdByFmainId(projectId); 
    List<TevalScoreEnd> scoreEndList = this.tevalScoreEndService.list((Wrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
        
        .eq(StrUtil.isNotEmpty(planId), TevalScoreEnd::getPlanId, planId))
        .eq(TevalScoreEnd::getFmainid, projectId))
        .orderByDesc(TevalScoreEnd::getTotal));
    List<TavgScoreEnd> tavgScoreEndList = this.tavgScoreEndService.list((Wrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
        
        .eq(StrUtil.isNotEmpty(planId), TavgScoreEnd::getPlanId, planId))
        .eq(TavgScoreEnd::getFmainid, projectId));
    if (ObjectUtil.isNotEmpty(tavgScoreEndList)) {
      TavgScoreEnd avg = tavgScoreEndList.get(0);
      TevalScoreEnd score = new TevalScoreEnd(avg.getCxx(), avg.getYyqj(), avg.getYjmb(), avg.getCgkhfs(), avg.getJcx(), avg.getKxx(), avg.getTotal());
      score.setTexpertName("平均分");
      scoreEndList.add(score);
    } 
    ModelAndView mv = new ModelAndView((View)new JeecgEntityExcelView());
    mv.addObject("fileName", "专家打分情况");
    mv.addObject("entity", TevalScoreEnd.class);
    mv.addObject("params", new ExportParams("专家打分情况", "专家打分情况"));
    mv.addObject("data", scoreEndList);
    return mv;
  }
  
  @AutoLog("项目-分页列表查询")
  @ApiOperation(value = "项目-分页列表查询", notes = "项目-分页列表查询")
  @GetMapping({"/waitList"})
  public Result<?> waitList(EvalProposal evalProposal, HttpServletRequest request, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize) {
    LoginUser sysUser = (LoginUser)SecurityUtils.getSubject().getPrincipal();
    QueryWrapper<Texpert> queryWrapper = new QueryWrapper();
    queryWrapper.eq("phone", sysUser.getPhone());
    Texpert texpert = (Texpert)this.texpertService.getOne((Wrapper)queryWrapper);
    String expertId = texpert.getId();
    List<TreviewPlan> treviewPlanList = this.treviewPlanService.list((Wrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper()).like(TreviewPlan::getExpertId, expertId)).in(TreviewPlan::getPlanStatus, new Object[] { "待评审", "评审中", "待结束" }));
    List<String> collect = (List<String>)treviewPlanList.stream().map(v -> v.getProjectId()).collect(Collectors.toList());
    Map<String, List<String>> map = new HashMap<>();
    for (TreviewPlan t : treviewPlanList)
      map.put(t.getId(), Arrays.asList(t.getProjectId().split(","))); 
    List<String> projectIdList = new ArrayList<>();
    for (String projectId : collect) {
      if (projectId != null)
        projectIdList.addAll(Arrays.asList(projectId.split(","))); 
    } 
    if (StrUtil.isNotEmpty(evalProposal.getExpertPhone())) {
      QueryWrapper<Texpert> q = new QueryWrapper();
      q.eq("phone", evalProposal.getExpertPhone());
      Texpert tx = (Texpert)this.texpertService.getOne((Wrapper)q);
      evalProposal.setExpertName(tx.getName());
      evalProposal.setDomain(tx.getTechnosphere());
    } 
    Page<EvalProposal> page = new Page(pageNo.intValue(), pageSize.intValue());
    IPage<EvalProposal> pageList = this.evalProposalService.pageList(page, evalProposal, projectIdList);
    Map<String, List<EvalProposal>> map3 = new HashMap<>();
    List<EvalProposal> list = pageList.getRecords();
    for (Map.Entry<String, List<String>> entry : map.entrySet()) {
      List<String> pro = entry.getValue();
      List<EvalProposal> evalProposalList = new ArrayList<>();
      for (int i = pro.size() - 1; i >= 0; i--) {
        String id = pro.get(i);
        List<EvalProposal> listi = (List<EvalProposal>)list.stream().filter(v -> v.getId().equals(id)).collect(Collectors.toList());
        evalProposalList.addAll(listi);
      } 
      map3.put(entry.getKey(), evalProposalList);
    } 
    List<TreviewPlan> noOverTimeProject = new ArrayList<>();
    for (TreviewPlan tp : treviewPlanList) {
      String planStatus = tp.getPlanStatus();
      if (!"评审中".equals(planStatus))
        continue; 
      Boolean isAdd = this.evalProposalService.selectExpertScore(texpert, tp);
      if (isAdd.booleanValue())
        noOverTimeProject.add(tp); 
    } 
    Map<String, List<TreviewPlan>> map1 = new HashMap<>();
    map1.put("需要操作项目", noOverTimeProject);
    Map<Integer, Object> map2 = new HashMap<>();
    map2.put(Integer.valueOf(1), map3);
    map2.put(Integer.valueOf(2), map1);
    return Result.ok(map2);
  }
}
